const users = [
    { id: 1, name: 'reza', age: 10 },
    { id: 2, name: 'zahra', age: 12 },
    { id: 3, name: 'nahid', age: 13 },
    { id: 4, name: 'amin', age: 14 },
    { id: 5, name: 'kosar', age: 15 },
];

class Controller {
    // get all users
    async getUsers() {
        return new Promise((resolve, _) => resolve(users));
    }
    // get a single user
    async getUser(id) {
        return new Promise((resolve, reject) => {
            // get the user
            let user = users.find((user) => user.id === parseInt(id));
            if (user) {
                // return the user
                resolve(user);
            } else {
                // return an error
                reject(`User with id ${id} not found `);
            }
        });
    }
    // get a single user base on name and age
    async getUserDetail(name, age) {
        return new Promise((resolve, reject) => {
            // get the user
            let user = users.find((user) => (user.name === name && user.age === parseInt(age)));
            if (user) {
                // return the user
                resolve(user);
            } else {
                // return an error
                reject(`User with name ${name} not found `);
            }
        });
    }


    // create a user
    async createUser(user) {
        return new Promise((resolve, _) => {
            let newUser = {
                id: Math.floor(6 + Math.random() * 10),
                ...user,
            };

            resolve(newUser);
        });
    }

    // delete a user
    async deleteUser(id) {
        return new Promise((resolve, reject) => {
            // get the user
            let user = users.find((user) => user.id === parseInt(id));
            // if no user, return an error
            if (!user) {
                reject(`No user with id ${id} found`);
            }
            // else, return a success message
            resolve(`User deleted successfully`);
        });
    }

    // update a user
    async updateUser(id) {
        return new Promise((resolve, reject) => {
            // get the user.
            let user = users.find((user) => user.id === parseInt(id));
            // if no user, return an error
            if (!user) {
                reject(`No user with id ${id} found`);
            }
            //else, update it by setting completed to true
            user["completed"] = true;
            // return the updated user
            resolve('user updated');
        });
    }
}

module.exports = Controller;