const router = {
  '/users': async (req, res) => {
    // const url = req.url;
    const { url, method } = req;
    console.log(method);
    const users = await new user().getUsers();
    res.setHeader('Content-Type', 'application/json');
    res.write(JSON.stringify(users));

    return res.end();
  },
  '/user/:id': async (req, res) => {
    const { url, method } = req;
    if (req.url.match(/\/user\/id=([0-9]+)/)) {
      console.log(req.method);
      const id = req.url.split("/")[2];
      // console.log(id);
      const users = await new user().getUser(id);
      res.setHeader('Content-Type', 'application/json');
      res.write(JSON.stringify(users));
    }
    return res.end();
  },
  '404': (req, res) => {
    const { url } = req;
    res.setHeader('Content-Type', 'application/json');
    res.write(JSON.stringify({ message: '404-not found' }));
    return res.end();
  }


};


const requestHandler = (req, res) => {
  const { url, method } = req;
  req.query_object = {}; // modify req object
  const url_arr = url.split("/");
  const path_arr = [];
  let is_pattern, found_key = null;

  Object.keys(router).map((path, ind) => {
    path_arr = path.split("/");
    //check length of url components
    if (url_arr.length !== path_arr.length) {
      //console.log("length not matched");
      return;
    } else {
      console.log("============path_arr : ", path_arr);
      path_arr.map((item, index) => {
        if (item) {
          //ignore pattern placeholders for exact url segment match
          is_pattern = item.indexOf(':') == 0;
          if (is_pattern && url_arr[index]) { // then place pattern corresponding value
            req.query_object[item.replace(":", "")] = url_arr[index];
            found_key = path;
          } else if (url_arr[index] === item) {
            //then compare string literals for fast performance
            req.query_object[item] = item;
            found_key = path;
          } else {
            found_key = null;
            return;
          }
        }


      });
      //found_key = path;

    }
  });

  if (found_key !== null) {
    return router[found_key](req, res);
  } else {
    return router['404'](req, res);
  }
};

module.exports = requestHandler;
// requestHandler({
//   url: '/users'
// }, null);
// requestHandler({
//   url: '/users/ali'
// }, null);
// requestHandler({
//   url: '/contact-us'
// }, null);
// requestHandler({
//   url: '/users/1234'
// }, null);
// requestHandler({
//   url: '/users/1234/profile'
// }, null);