const url = require('url');
const user = require("./controller");
const { getReqData } = require("./utils");
//  /\/user\?name=[a-zA-Z]+&age=([0-9]+)/
// let x = new RegExp("/\/user\/([0-9]+)");
const router = {
    '/users': async (req, res) => {//show users
        // const url = req.url;
        const { url, method } = req;
        req.method = "GET";
        const users = await new user().getUsers();
        console.log(req.method);

        res.setHeader('Content-Type', 'application/json');
        res.write(JSON.stringify(users));

        return res.end();
    },
    '/user?id=1':async (req, res) => {//show user base id
        const { url, method } = req;
        if (req.url.match(/\/user\?id=([0-9]+)/)) {
            const parameter = req.url.split("?")[1];
            const id = parameter.split("=")[1];
            const users = await new user().getUser(id);
            res.setHeader('Content-Type', 'application/json');
            res.write(JSON.stringify(users));
        }
        return res.end();
    },
    '/user?name=amin&age=14':async (req, res) => {//show user base name and age
        const { url, method } = req;
        if (req.url.match(/\/user\?name=([a-zA-Z])+\&age=14/)) {
            const url_arr = req.url.split("?");
            const parameter = url_arr[1].split("&");
            const name = parameter[0].split("=")[1];
            const age = parameter[1].split("=")[1];
            const users = await new user().getUserDetail(name,age);
            res.setHeader('Content-Type', 'application/json');
            res.write(JSON.stringify(users));
        }
        return res.end();
    },
    '/users': async (req, res) => {//CREATE USER
        const { url, method } = req;
        req.method = "POST";
        let users_data = await getReqData(req);
        let users = await new user().createUser(JSON.parse(users_data));

        res.setHeader('Content-Type', 'application/json');
        res.write(JSON.stringify(users));

        return res.end();
    },
    '/user?id=2':async (req, res) => {//DELETE
        const { url, method } = req;
        req.method = "DELETE";
        if (req.url.match(/\/user\?id=([0-9]+)/)) {
            const parameter = req.url.split("?")[1];
            const id = parameter.split("=")[1];
            const users = await new user().deleteUser(id);
            res.setHeader('Content-Type', 'application/json');
            res.write(JSON.stringify(users));
        }
        return res.end();
    },
    '/user?id=3':async (req, res) => {//UPDATE
        const { url, method } = req;
        req.method = "PUT";
        if (req.url.match(/\/user\?id=([0-9]+)/)) {
            const parameter = req.url.split("?")[1];
            const id = parameter.split("=")[1];
            const users = await new user().updateUser(id);
            res.setHeader('Content-Type', 'application/json');
            res.write(JSON.stringify(users));
        }
        return res.end();
    },
    '404': (req, res) => {
        const { url } = req;
        res.setHeader('Content-Type', 'application/json');
        res.write(JSON.stringify({ message: '404-not found' }));
        return res.end();
    }
}

const requestHandler = (req, res) => {
    const { url, method } = req;
    if (url in router) {
        return router[url](req, res);
    }

    return router['404'](req, res);
};

module.exports = requestHandler;